*exercise 6.11 Hill et al.
clear

use cobb.dta,clear


des
* trasformo in log

gen lnq=ln(q)

gen lnl=ln(l)

gen lnk=ln(k)



regress lnq lnl lnk

*perche non significativi?

corr lnl lnk

predict myres,res


gen sqres=myres^2


sum sqres

dis r(sum)

dis e(rss)


* impongo vincolo beta_k=0
regress lnq lnl 

dis e(rss)


*genero F

dis ((1.4319457-1.4093887)/1)/(1.4093887/(33-3))


dis Ftail(1,30,.48014433)


* impongo beta_l+beta_k=1  che implica beta_k= 1-beta_l

* la regressione diventa  ln(q/k)  = beta_0 +beta_l ln(l/k)

gen lnq_k=ln(q/k)

gen lnl_k=ln(l/k)


reg lnq_k lnl_k


* quanto  beta_k e il suo standard error?


* testare con e senza omoschedaticit

regress lnq lnl lnk

* prima abbiamo visto che il test sul coefficiente di beta_k=0 era


dis Ftail(1,30,.48014433)


* il test equivale a:

test lnk

* il quadrato del t equivale alla statistica F calcolata prima
dis  (.4877301 /.7038722 )^2 


* cosa cambia con robust standard error?

regress lnq lnl lnk,r

*statistica F con robust standard error
test lnk

dis ( .4877301/.5152238)^2

*chiaramente la statistica F calcolata usando la somma dei residui al quadrato 
*del modello ristretto e non  uguale a prima




* testiamo rendimenti di scala costanti

regress lnq lnl lnk


lincom lnl+lnk-1


*testiamo significativit congiunta (sono due test su coefficient diversi)

test lnl lnk

* stata lo produce di default
reg lnq lnl lnk



****
* costruzione test singolo su piu' coefficienti

regress lnq lnl lnk

lincom lnk+lnk-1

* uso matrica varianza covarianze stimate dei beta

mat list e(V)

/*

symmetric e(V)[3,3]
              lnl         lnk       _cons
  lnl   .66657077
  lnk   -.5664367   .49543606
_cons  -.34056247    .2477981    .2982604

*/

*var(beta_l+beta_k-1)=var(beta_l)+var(beta_k)+2*cov(beta_l,beta_k)
* valore statistica
dis _b[lnk]+_b[lnl]-1
* e suo standard error
dis  (.66657077+ .49543606+2*(-.5664367))^0.5
********************************************************************************

*es 7.10
clear

use means.dta,clear
des


sum *


sum lnprice lnunits if d==1

sum lnprice lnunits if d==1 & izlaw==1
sum lnprice lnunits if d==1 & izlaw==0


sum lnprice lnunits if d==0 & izlaw==1
sum lnprice lnunits if d==0 & izlaw==0


gen int_izlaw_d=izlaw*d

regress lnprice d izlaw int_izlaw_d
estimates store lnp1

regress lnunits d izlaw int_izlaw_d
estimates store lnu1

* aggiungendo controlli

des
regress lnprice d izlaw int_izlaw_d lmedhhinc
estimates store lnp2


regress lnunits d izlaw int_izlaw_d lmedhhinc
estimates store lnu2


regress lnprice d izlaw int_izlaw_d lmedhhinc educattain  lpop
estimates store lnp3

regress lnunits d izlaw int_izlaw_d lmedhhinc educattain  lpop
estimates store lnu3




estout lnp*, cells(b(star  fmt(%9.3f)) se(par  fmt(%9.3f))) stats(r2_a,fmt(%9.5f)) style(fixed)

********************************************************************


* simulazione modelli autoregressivi

clear
*version 11.1
quietly set obs 100
set seed 10101
gen t=_n

tsset t

gen u=rnormal(0,1)
local beta1=0.499

quietly gen yt= u in 1
quietly replace yt=`beta1'*yt[_n-1]+u in 2/L


two line yt t if t>1

corrgram y


dfuller yt, lags(1)
* 0.59   -1.09
*-0.3 0.8

reg yt L.yt,r
estimates store ar11

reg yt L.yt L2.yt,r
estimates store ar12

estimates stats *





estimates clear




clear
*version 11.1
quietly set obs 100
set seed 10101
gen t=_n

tsset t

gen u=rnormal(0,1)
local beta1=0.5
local beta2=0.45
quietly gen yt= u in 1
*quietly replace yt=`beta1'*yt[_n-1]+u in 2/L
quietly replace yt=`beta1'*yt[_n-1]+u in 2
quietly replace yt=`beta1'*yt[_n-1]+`beta2'*yt[_n-2]+u in 3/L

* stability -1< beta2 <  1 - |beta1|

two line yt t if t>1

corrgram yt

reg yt L.yt,r
estimates store ar21

reg yt L.yt L2.yt,r
estimates store ar22


reg yt L.yt L2.yt L3.yt,r
estimates store ar23

estimates stats *


* 0.59   -1.09
*-0.3 0.8


